require "blogtext/audio"
require "blogtext/image"
require "blogtext/io"
require "blogtext/link"
require "blogtext/paragraph"
require "blogtext/quote"
require "blogtext/version"
require "blogtext/video"

module Blogtext

  def self.new_contents(arr)
    arr.join("\n")
  end

  def self.perform
    res = []
    @contents.each_with_index do |l,i|
      res.push("<h1>#{l.strip}</h1>") if (i == 0)
      res.push("<h3>#{l.strip}</h3>") if (i == 1)
      res.push(Video.add(l)) if l.start_with?("[video]")
      res.push(Image.add(l)) if l.start_with?("[image]")
      res.push(Quote.add(l)) if l.start_with?("[quote]")
      res.push(Paragraph.add(l.strip)) if ((i>1) && !l.start_with?("[quote]","[image]","[video]"))
    end
    @newcontents = new_contents(res)
  end
  
  def self.convert filename
    @contents = IO.read(filename)
    perform
  end

  def self.cli_convert
    @filename = ARGV[0]
    puts @filename
    @changes = convert @filename
    IO.write(@filename,@changes)
  end

end
